  Program
  Map
  end

  Include('tSQLite.inc'),Once

SQLite  Class(ToySQLite).

qList  Queue
Name     String(40)
Age      Long
Height   Real
Weight   Decimal(15,3,0)
FileName CString(File:MaxFileName)  !  
Photo    CString(File:MaxFileName)  ! :   / : ID      qFiles
      end

  Code
  Locale('CLACHARSET','WINDOWS')    !  
  Locale('CLACOLSEQ','WINDOWS')
  Locale('CLACASE','WINDOWS')

  !   
  qList.Name = '';  qList.Age = 18; qList.Height = 1.68; qList.Weight = 65.547; qList.FileName = 'picture1.jpg'; qList.Photo = qList.FileName; Add(qList)
  qList.Name = ''; qList.Age = 20; qList.Height = 1.70; qList.Weight = 72;     qList.FileName = 'picture2.jpg'; qList.Photo = qList.FileName; Add(qList)
  qList.Name = ''; qList.Age = 22; qList.Height = 1.84; qList.Weight = 59.120; qList.FileName = 'picture3.jpg'; qList.Photo = qList.FileName; Add(qList)
  qList.Name = ''; qList.Age = 19; qList.Height = 1.67; qList.Weight = 66.6;   qList.FileName = 'picture4.jpg'; qList.Photo = qList.FileName; Add(qList)

  !   QUEUE / RECORD  
  If Exists('ToyTest.db') then Remove('ToyTest.db').

  If SQLite.OpenDB('ToyTest.db')

     SQLite.SetRule('Photo', 'IsFile',True)   !  Photo  ->      BLOB 
     SQLite.SetRule('Age',   'Ignore',True)   !  Age    ->  ( )
     SQLite.SetRule('Weight','IsReal',True)   !  Weight ->   REAL

                                              !   
     SQLite.StartWithNew('DROP TABLE IF EXISTS MyTable; CREATE TABLE MyTable (RecID INTEGER PRIMARY KEY AUTOINCREMENT,')
     SQLite.AddEnumTitle(qList,True)          !     + ')'

     If    Not SQLite.Exec() then Message('      !','',Icon:Exclamation,'&1. ')
     elsIf SQLite.Exec('BEGIN TRANSACTION')

        SQLite.QueueToTable(qList,'MyTable')  !    

        If SQLite.Exec('COMMIT') then Message('  ToyTest.db !','ToySQLite',Icon:Asterisk,'&1. ').  ! 
     end
     SQLite.CloseDB()
  end

  !   QUEUE / RECORD   
  Free(qList)
  If SQLite.OpenDB('ToyTest.db')

     SQLite.SetRule('Age','Ignore',True)      !    Age ->  ( ) - ..      SQLite

     SQLite.StartWithNew('SELECT ')
     SQLite.AddEnumField(qList)               !    
     SQLite.QueryStr.Cat(' FROM MyTable')
                                              !     qList (+ Blob    Self.qFiles)
     If    Not SQLite.Eviscerate(,qList) then Message('       !','',Icon:Exclamation,'&1. ')
     elsIf Records(qList) = 0            then Message('     !',                '',Icon:Exclamation,'&1. ')
     else
        Loop Index# = 1 to Records(qList)     !       
          Get(qList,Index#)
          File" = 'new1_' & qList.FileName    !   ,     
                                              !     BLOB   Self.qFiles  ID  qList.Photo
          SQLite.ContentToFile(qList.Photo,File")
          Message(qList.Name & '|: ' & File")
        end
     end
     SQLite.CloseDB()
  end

  !   QUEUE / RECORD   
  Free(qList)
  If SQLite.OpenDB('ToyTest.db')              !   
     SQLite.StartWithNew('SELECT * FROM MyTable')
                                              !    qList    (+ Blob    Self.qFiles)
     If    Not SQLite.Eviscerate(,qList,True) then Message('       !','',Icon:Exclamation,'&1. ')
     elsIf Records(qList) = 0                 then Message('     !',                '',Icon:Exclamation,'&1. ')
     else
        Loop Index# = 1 to Records(qList)     !       
          Get(qList,Index#)
          File" = 'new2_' & qList.FileName    !   ,     
                                              !     BLOB   Self.qFiles  ID  qList.Photo
          SQLite.ContentToFile(qList.Photo,File")
          Message(qList.Name & '|: ' & File")
        end
     end
     SQLite.CloseDB()
  end